import pandas as pd
import numpy as np

# load the data
df = pd.read_csv('crx.data')  # this reads in the file as a dataframe

print(df.Gender)   # you can access parts of the data frame

# change the labels from '+' and '-' to 1 and 0
df.approved[df.approved == '+']=1
df.approved[df.approved == '-']=0

# put together the training set
# here we will only use the following quantities for assessment: 
# gender, age, debt, years employed, prior default, credit score and income
feature_vector=np.transpose(np.array([np.array(df['Gender']),np.array(df['age']),np.array(df['debt']),np.array(df['yearsemployed']),np.array(df['priordefault']),np.array(df['employed']),np.array(df['creditscore']),np.array(df['income'])]))

# put together the labels
labels=np.array(df.approved)
 
# print the shapes
print(np.shape(feature_vector))
print(np.shape(labels)) 
 