# perform decision tree analysis of the iris dataset

import numpy as np # basically matlab
import matplotlib.pyplot as plt # for plotting
from sklearn import datasets # for dataset
from sklearn.model_selection import train_test_split # will split our data into training and testing 
from sklearn.tree import DecisionTreeClassifier # deicsition tree
from sklearn.metrics import accuracy_score, confusion_matrix  # assessing accuracy

# load in the iris dataset
iris = datasets.load_iris() # load the data
x_data = iris.data # extract inputs
y_data = iris.target # extract outputs

# for easy visualization we only look at first two features

x_data = x_data[:,0:2] # only use first 2 features
y_data = y_data[:,np.newaxis] # add extra dimension

# make sure the shape is as expected
print 'x_data shape =', x_data.shape
print 'y_data shape =', y_data.shape

# split the data into training (80%) and testing (20%)
x_train, x_test, y_train, y_test = train_test_split(x_data, y_data, test_size = 0.20)  

# define and fit the classifier
decision_tree_classifier = DecisionTreeClassifier() # here we use the default options

decision_tree_classifier.fit(x_train, y_train)  
 
# print out training accuracy
y_pred_train = decision_tree_classifier.predict(x_data)
print(accuracy_score(y_data,y_pred_train))

# make predictions for the testing data
y_pred = decision_tree_classifier.predict(x_test) 

# analyze the predictions
print(confusion_matrix(y_test,y_pred))  
print(accuracy_score(y_test,y_pred))

# exampine what the tree looks like 

# Exercises for you

# 1. Optimize the tree depth (max_depth) and minimum number of samples needed to split a 
#    node (min_samples_split) from 2 up to 30 (2, 4 ,6 , ... , 28, 30). Plot a surface of the 
#    validation accuracy for each max_depth and min_samples_split.  
# 2. Use all features (instead of the first two). How does accuracy change?