# perform support vector machine analysis of the iris dataset

import numpy as np # basically matlab
import matplotlib.pyplot as plt # for plotting
from sklearn import datasets # for dataset
from sklearn.model_selection import train_test_split # will split our data into training and testing 
from sklearn.svm import SVC  # support vector machine
from sklearn.metrics import classification_report, confusion_matrix  # assessing accuracy


# load in the iris dataset
iris = datasets.load_iris() # load the data
x_data = iris.data # extract inputs
y_data = iris.target # extract outputs

# for easy visualization we only look at first two features

x_data = x_data[:,0:2] # only use first 2 features
y_data = y_data[:,np.newaxis] # add extra dimension

# make sure the shape is as expected
print 'x_data shape =', x_data.shape
print 'y_data shape =', y_data.shape

# split the data into training (80%) and testing (20%)
x_train, x_test, y_train, y_test = train_test_split(x_data, y_data, test_size = 0.20)  

# define and fit the classifier
svclassifier = SVC(kernel='linear')  
svclassifier.fit(x_train, y_train)  

# make predictions for the testing data
y_pred = svclassifier.predict(x_test)  

# analyze the predictions
print(confusion_matrix(y_test,y_pred))  


# Exercises for you

# 1. Change from a 'linear' kernel to a polynomial kernel of degree 4 or a gaussian kernel
# 2. Use all features (instead of the first two). How does accuracy change?